#include <sdcc-lib.h>
#include <pic12f675.h>	// /usr/share/sdcc/include/pic/pic12f675.h

// $Revision: 1.3 $

//__code unsigned char at 0x2000 id_location[] = {'A', 'B', 'C', 'D', 0, 0, 0 };

unsigned int at 0x2007 __config =
	_CPD_OFF &
	_CP_OFF &
	_BODEN_ON &
	_MCLRE_OFF &
	_PWRTE_OFF &
	_WDT_OFF &
	_INTRC_OSC_NOCLKOUT;

__code unsigned char at 0x2100 eedata[] = {'d', 'u', 'm', 'm', 'y', 0 };

#define	LED1	GPIO0

volatile unsigned char waitCntS;
volatile unsigned char waitCntM;
volatile unsigned char waitCntL;

void waitS();
void waitM();
void waitL();

void Intr(void) __interrupt 0 {  
	T0IF = 0;	// Clear timer interrupt
}

void main(void) {
					//   543210
	GPIO	= 0x00;	// --000000		GPIO3: Input Only
	CMCON	= 0x07;
	ANSEL	= 0x00;
	TRISIO	= 0x08;	// --001000		1: 入力, 0: 出力

	while(1) {
		LED1 = 0;

		waitCntL = 10;
		waitL();

		LED1 = 1;

		waitCntL = 5;
		waitL();
	}
}

void waitS() {
	_asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(小)
						;			;
						;			;	    * 4MHz 時
						;			;				LD		A, 10					; 10を指定すると、
						;			;				CALL	WAITnx3p5u				; 2行で 10 x 3 + 5 = 35us 消費
						;			;
WAITnx3p5u:					;			WAITnx3p5u:
		movwf	_waitCntS		;							LD		(_waitCntS), A
WAITnx3p5u1:					;			WAITnx3p5u1:
		decfsz	_waitCntS		
		goto	WAITnx3p5u1		;							DJNZ	(_waitCntS), WAITnx3p5u1
						;			;				RET
	_endasm;
}

void waitM() {
	_asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(中)
						;			;
						;			;	    * 4MHz 時
						;			;				LD		A, 20					; 0.01秒の場合、20を指定すると、
						;			;				CALL	WAITnx500m35u			; 2行で 20 x 500 - 35 = 9.965ms 消費する
						;			;
WAITnx500m35u:					;			WAITnx500m35u:
		movwf	_waitCntM		;							LD		(_waitCntM), A
		goto	WAITnx500m35u2		;							JP		WAITnx500m35u2
WAITnx500m35u1:	nop				;			WAITnx500m35u1:	NOP
		movlw	12			;							LD		A, 12					;  12 x 3 + 5 =  41us
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				;		の時間待ち
WAITnx500m35u2:	movlw	150			;			WAITnx500m35u2:	LD		A, 150					; 150 x 3 + 5 = 455us
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				;		の時間待ち
		decfsz	_waitCntM		
		goto	WAITnx500m35u1		;							DJNZ	(_waitCntM), WAITnx500m35u1
						;			;				RET
	_endasm;
}

void waitL() {
	_asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(大)
						;			;
						;			;	    * 4MHz 時
						;			;				LD		A, 10					; 1秒の場合、10を指定すると、
						;			;				CALL	WAITnx01sm25u			; 2行で 10 x 100ms - 25us 消費する
						;			;
WAITnx01sm25u:					;			WAITnx01sm25u:
		movwf	_waitCntL		;							LD		(_waitCntL), A
		goto	WAITnx01sm25u2		;							JP		WAITnx01sm25u2
WAITnx01sm25u1:	movlw	9			;			WAITnx01sm25u1:	LD		A, 9
		call	WAITnx3p5u		;							CALL	WAITnx3p5u
WAITnx01sm25u2:	movlw	200			;			WAITnx01sm25u2:	LD		A, 200
		call	WAITnx500m35u		;							CALL	WAITnx500m35u
		decfsz	_waitCntL		
		goto	WAITnx01sm25u1		;							DJNZ	(_waitCntL), WAITnx01sm25u1
						;			;				RET
	_endasm;
}

